#!/bin/sh

LOG_PIPE=log.pipe
rm -f LOG_PIPE
mkfifo ${LOG_PIPE}
LOG_FILE=log.file
rm -f LOG_FILE
tee < ${LOG_PIPE} ${LOG_FILE} &

exec  > ${LOG_PIPE}
exec  2> ${LOG_PIPE}

MIRROR='http://cdn.bspanel.ru'
addr=$(echo "${SSH_CONNECTION}" | awk '{print $3}')
longbit=$(getconf LONG_BIT)
apache2='/etc/apache2/conf-available/bspanel.conf'

Infon() {
	printf "\033[1;32m$@\033[0m"
}
Info()
{
	Infon "$@\n"
}
Error()
{
	printf "\033[1;33m$@\033[0m\n"
}
Error_n()
{
	Error "- - - $@"
}
Error_s()
{
	Error "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - "
}
log_s()
{
	Info "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - "
}
log_n()
{
	Info "\033[1;34m$@\033[0m\n"
}
log_red()
{
	Info "\033[1;31m$@\033[0m\n"
}
log_t()
{
	log_s
	Info "- - - $@"
	log_s
}
lines()
{
	Info "${green}------------------------------------------------------------------------------"
}
wow()
{
	lines
}
wow1()
{
	lines
}
infomenu()
{
	Info "${yellow}------------- | ${CYAN}Добро пожаловать, в установочное меню ${red}BSPanel${blue}$(tput setf 2) | --------------"
}
info()
{
	printf "\033[1;33m$@\033[0m\n"
}
info_n()
{
	info "- - - $@"
}
lines_1()
{
	lines_2 "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - "
}
lines_2()
{
	printf "\033[1;33m$@\033[0m\n"
}
log_n11()
{
	Info "- - - $@"
}
log_tt()
{
	Info "• —————————————————————————— ${red}$@${green} ——————————————————————————— • "
}

red=$(tput setf 4)
green=$(tput setf 2)
cyan=$(tput setaf 6)
reset=$(tput sgr0)
toend=$(tput hpa $(tput cols))$(tput cub 6)

install_bspanel() # by Zalkarbek
{
	clear
	if [ -f "/var/www/system/data/config.php" ]; then
		echo "${green}Control Panel Already Installed${reset} ${toend}${red}[ERROR]${reset}"
		echo "${red}[EXIT]${cyan} 1."
		sleep 1
		echo "${red}[EXIT]${cyan} 2.."
		sleep 1
		echo "${red}[EXIT]${cyan} 3..."
		menu
	else
		Installation "false" "${green}Installation BSPanel...${reset}" "apt-get update && apt-get upgrade -y; apt-get install -y lsb-release"
		Installation "${5}" "${green}Installation BSPanel...${reset}" "clear"
	fi

	if [ "${3}" = "bspanel" ]; then 
		max=23 
	else 
		max=18 
	fi
	if [ "${1}" = "ip" ]; then 
		domain=$addr 
	else 
		domain=${1} 
	fi

	#Installation "true" "[1/${max}] Adding packages..." "echo \"deb http://mirror.yandex.ru/debian $(lsb_release -sc) main\" >> /etc/apt/sources.lis; echo \"deb-src http://mirror.yandex.ru/debian $(lsb_release -sc) main\" >> /etc/apt/sources.lis; echo \"deb http://mirror.yandex.ru/debian $(lsb_release -sc)-updates main\" >> /etc/apt/sources.lis; echo \"deb-src http://mirror.yandex.ru/debian $(lsb_release -sc)-updates main\" >> /etc/apt/sources.lis; echo \"deb https://mirror.yandex.ru/debian-security $(lsb_release -sc)/updates main\" >> /etc/apt/sources.lis; echo \"deb-src https://mirror.yandex.ru/debian-security $(lsb_release -sc)/updates main\" >> /etc/apt/sources.lis"
	Installation "${5}" "[1/${max}] Adding packages..." "echo -n > /etc/apt/sources.list; echo \"deb http://ftp.ru.debian.org/debian/ $(lsb_release -sc) main\" > /etc/apt/sources.list; echo \"deb-src http://ftp.ru.debian.org/debian/ $(lsb_release -sc) main\" >> /etc/apt/sources.list; echo \"deb http://security.debian.org/ $(lsb_release -sc)/updates main\" >> /etc/apt/sources.list; echo \"deb-src http://security.debian.org/ $(lsb_release -sc)/updates main\" >> /etc/apt/sources.list; echo \"deb http://ftp.ru.debian.org/debian/ $(lsb_release -sc)-updates main\" >> /etc/apt/sources.list; echo \"deb-src http://ftp.ru.debian.org/debian/ $(lsb_release -sc)-updates main\" >> /etc/apt/sources.list"
	Installation "${5}" "[2/${max}] Updating packages..." "apt-get update && apt-get upgrade -y"
	Installation "${5}" "[3/${max}] Packages installation..." "apt-get install -y apt-transport-https ca-certificates apt-utils pwgen wget dialog cron sudo lib32z1 expect nload screen htop nano tcpdump zip unzip mc curl ssh bc"
	sqlpass=$(pwgen -cns -1 16) ftpass=$(pwgen -cns -1 16) ckey=$(pwgen -cns -1 6) PassGen=$(pwgen -cns -1 7) newpass=`wget -qO- http://system.bspanel.ru/api/md5.php?passwd=${PassGen} | sed -e 's/<[^>]*>//g'`;
	if [ "${4}" = "1" ]; then
		Installation "${5}" "[4/${max}] Adding packages for php 5.6..." "apt-get update"
		Installation "${5}" "[5/${max}] Installation PHP 5.6..." "apt-get install -y php5"
		Installation "${5}" "[6/${max}] Installation packages PHP..." "apt-get install -y php5-dev php5-zip php5-gd php5-curl php5-memcache memcached php5-json php5-xml php5-mbstring php5-mysql libapache2-mod-php5 php5-ssh2 php-pclzip php-pear"
	else
		Installation "${5}" "[4/${max}] Adding packages for php 5.6..." "wget https://packages.sury.org/php/apt.gpg -O /etc/apt/trusted.gpg.d/php.gpg; sh -c 'echo \"deb https://packages.sury.org/php/ $(lsb_release -sc) main\" > /etc/apt/sources.list.d/php.list'; apt-get update"
		Installation "${5}" "[5/${max}] Installation PHP 5.6..." "apt-get install -y php5.6"
		Installation "${5}" "[6/${max}] Installation packages PHP..." "apt-get install -y php5.6-dev php5.6-zip php5.6-gd php5.6-curl php5.6-memcache php5.6-memcached memcached php5.6-json php5.6-xml php5.6-mbstring php5.6-mysql libapache2-mod-php5.6 php5.6-ssh2 php-pclzip php-pear"
	fi
	Installation "${5}" "[7/${max}] Installation Apache2..." "apt-get install -y apache2"
	Installation "${5}" "[8/${max}] Installation MySQL 5.6..." "wget https://dev.mysql.com/get/mysql-apt-config_0.8.14-1_all.deb; export DEBIAN_FRONTEND=noninteractive; echo mysql-apt-config mysql-apt-config/select-server select mysql-5.6 | debconf-set-selections; echo mysql-apt-config mysql-apt-config/select-product select Ok | debconf-set-selections; dpkg -i mysql-apt-config_0.8.14-1_all.deb && rm mysql-apt-config_0.8.14-1_all.deb; echo mysql-community-server mysql-community-server/root-pass password \"${sqlpass}\" | debconf-set-selections; echo mysql-community-server mysql-community-server/re-root-pass password \"${sqlpass}\" | debconf-set-selections; apt-get update; apt-get install -y mysql-server"
	Installation "${5}" "[9/${max}] Installation phpMyAdmin..." "echo \"phpmyadmin phpmyadmin/dbconfig-install boolean true\" | debconf-set-selections; echo \"phpmyadmin phpmyadmin/mysql/admin-user string root\" | debconf-set-selections; echo \"phpmyadmin phpmyadmin/mysql/admin-pass password ${sqlpass}\" | debconf-set-selections; echo \"phpmyadmin phpmyadmin/mysql/app-pass password ${sqlpass}\" | debconf-set-selections; echo \"phpmyadmin phpmyadmin/app-password-confirm password ${sqlpass}\" | debconf-set-selections; echo 'phpmyadmin phpmyadmin/reconfigure-webserver multiselect apache2' | debconf-set-selections; apt-get install -y phpmyadmin"
	Installation "${5}" "[10/${max}] Creating virtualhost Apache2..." "cd /etc/apache2/sites-available; sed -i \"/Listen 80/d\" *; echo \"Listen 80\">${apache2}; echo \"<VirtualHost *:80>\">${apache2}; echo \"	ServerName ${domain}\">>${apache2}; echo \"	DocumentRoot /var/www\">>${apache2}; echo \"	<Directory /var/www/>\">>${apache2}; echo \"	Options Indexes FollowSymLinks MultiViews\">>${apache2}; echo \"	AllowOverride All\">>${apache2}; echo \"	Order allow,deny\">>${apache2}; echo \"	allow from all\">>${apache2}; echo \"	</Directory>\">>${apache2}; echo \"	ErrorLog \${APACHE_LOG_DIR}/error.log\">>${apache2}; echo \"	LogLevel warn\">>${apache2}; echo \"	CustomLog \${APACHE_LOG_DIR}/access.log combined\">>${apache2}; echo \"</VirtualHost>\">>${apache2}"
	Installation "${5}" "[11/${max}] Enabling module Apache2 and Restarting service Apache2..." "a2enconf bspanel.conf; systemctl reload apache2; a2enmod php5.6; a2enmod rewrite; service apache2 restart"
	Installation "${5}" "[12/${max}] Adding cron task..." "sed -i \"s/320/0/g\" /etc/crontab; wget ${MIRROR}/v3/cron.txt; sed -i \"s/key123/${ckey}/g\" cron.txt; cat cron.txt | tr -d '\r' >> /etc/crontab; sed -i '/^$/d' /etc/crontab; crontab -u root /etc/crontab"
	Installation "${5}" "[13/${max}] Downloading and Installation BSPanel..." "cd /var/www/; wget ${MIRROR}/v3/bspanel.zip; unzip bspanel.zip; rm bspanel.zip; chown -R www-data:www-data /var/www && chmod -R 775 /var/www; cd"
	if [ "${4}" = "1" ]; then
		Installation "${5}" "[14/${max}] Configuring time..." "timedatectl set-timezone Europe/Moscow; dpkg-reconfigure tzdata -f noninteractive; sed -i -r 's~^;date\.timezone =$~date.timezone = \"Europe/Moscow\"~' /etc/php5/cli/php.ini; sed -i -r 's~^;date\.timezone =$~date.timezone = \"Europe/Moscow\"~' /etc/php5/apache2/php.ini"
	else
		Installation "${5}" "[14/${max}] Configuring time..." "timedatectl set-timezone Europe/Moscow; dpkg-reconfigure tzdata -f noninteractive; sed -i -r 's~^;date\.timezone =$~date.timezone = \"Europe/Moscow\"~' /etc/php/5.6/cli/php.ini; sed -i -r 's~^;date\.timezone =$~date.timezone = \"Europe/Moscow\"~' /etc/php/5.6/apache2/php.ini"
	fi
	if [ "${3}" = "bspanel" ]; then
		Installation "${5}" "[15/${max}] Configuring BSPanel..." "wget ${MIRROR}/v3/bspanel.sql; sed -i \"s/mysqlp/${sqlpass}/g\" /var/www/system/data/mysql.php; sed -i \"s/bspanel_addr/${addr}/g\" /var/www/system/data/web.php; sed -i \"s/bspanel_sshpass/${2}/g\" /var/www/system/data/web.php; sed -i \"s/bspanel_domain/${domain}/g\" /var/www/system/data/web.php; sed -i \"s/bspanel_sqlpass/${sqlpass}/g\" /var/www/system/data/web.php; sed -i \"s/bspanel_domain/${domain}/g\" /var/www/system/data/config.php; sed -i \"s/bspanel_addr/${addr}/g\" /var/www/system/data/config.php; sed -i \"s/key123/${ckey}/g\" /var/www/system/data/config.php; sed -i \"s/bspanel_random_passwd/${PassGen}/g\" /var/www/system/data/config.php; sed -i \"s/bspanel_domain/${domain}/g\" /root/bspanel.sql; sed -i \"s/bspanel_addr/${addr}/g\" /root/bspanel.sql; sed -i \"s/bspanel_sqlpass/${sqlpass}/g\" /root/bspanel.sql; sed -i \"s/bspanel_sshpass/${2}/g\" /root/bspanel.sql; sed -i \"s/bspanel_accountpass/${newpass}/g\" /root/bspanel.sql; sed -i \"${addr} ${domain}\" /etc/hosts; mysql -u root -p${sqlpass} -e \"CREATE DATABASE bspanel CHARACTER SET utf8 COLLATE utf8_general_ci;\"; mysql -u root -p${sqlpass} bspanel < bspanel.sql && rm bspanel.sql; mysql -u root -p${sqlpass} -e \"SET global sql_mode='NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION';\""
		unbuffer expect -c "
		spawn mysql_config_editor set --login-path=local --host=localhost --user=root --password
		expect -nocase \"Enter password:\" {send \"${sqlpass}\r\"; interact}" > /dev/null 2>&1
		Installation "${5}" "[16/${max}] Required packages for the server side..." "serivce apache2 stop; apt-get install -y ethstatus qstat gdb lib32gcc1 gcc-multilib lib32stdc++6 libreadline5 ntpdate lsof; sudo dpkg --add-architecture i386"
		Installation "${5}" "[17/${max}] Installation Java 8..." "wget ${MIRROR}/v3/rep/jre-linux.tar.gz; tar xvfz jre-linux.tar.gz; mkdir /usr/lib/jvm; mv jre1.8.0_45 /usr/lib/jvm/jre1.8.0_45; update-alternatives --install /usr/bin/java java /usr/lib/jvm/jre1.8.0_45/bin/java 1; update-alternatives --config java && rm jre-linux.tar.gz"
		Installation "${5}" "[18/${max}] Installation and configure 'iptables, rclocal, geoip'..." "wget -O rclocal ${MIRROR}/files/debian/rclocal/rclocal.txt; sed -i '14d' /etc/rc.local; cat rclocal >> /etc/rc.local && touch /root/iptables_block; echo \"UseDNS no\" >> /etc/ssh/sshd_config && echo \"UTC=no\" >> /etc/default/rcS; rm -rf rclocal; sudo apt-get --yes --force-yes install xtables-addons-common; sudo apt-get --yes --force-yes install libtext-csv-xs-perl libxml-csv-perl libtext-csv-perl unzip; sudo mkdir -p /usr/share/xt_geoip/; mkdir geoiptmp; cd geoiptmp /usr/lib/xtables-addons/xt_geoip_dl; sudo /usr/lib/xtables-addons/xt_geoip_build GeoIPv6.csv GeoIPCountryWhois.csv -D /usr/share/xt_geoip; cd && rm -rf geoiptmp"
		Installation "${5}" "[19/${max}] Installation Nginx..." "rm nginx; wget -O nginx $MIRROR/files/debian/nginx/nginx.txt; service apache2 stop; apt-get install -y nginx; mkdir -p /var/nginx/; rm -rf /etc/nginx/nginx.conf; mv nginx /etc/nginx/nginx.conf; service nginx restart; service apache2 start; rm -rf nginx"
		Installation "${5}" "[20/${max}] Installation and configure ProFTPD..." "wget -O proftpd $MIRROR/files/debian/proftpd/proftpd.txt;wget -O proftpd_modules $MIRROR/files/debian/proftpd/proftpd_modules.txt;wget -O proftpd_sql $MIRROR/files/debian/proftpd/proftpd_sql.txt;echo PURGE | debconf-communicate proftpd-basic;echo proftpd-basic shared/proftpd/inetd_or_standalone select standalone | debconf-set-selections;apt-get install -y proftpd-basic proftpd-mod-mysql;rm -rf /etc/proftpd/proftpd.conf/etc/proftpd/modules.conf /etc/proftpd/sql.conf;mv proftpd /etc/proftpd/proftpd.conf;mv proftpd_modules /etc/proftpd/modules.conf;mv proftpd_sql /etc/proftpd/sql.conf;rm -rf proftpd proftpd_modules proftpd_sql;mkdir -p /copy /servers /servers/cs /servers/cssold /servers/css /servers/csgo /servers/samp /servers/crmp /servers/mta /servers/mc /path/steam /var/nginx;mkdir -p /path/cs /path/css /path/cssold /path/csgo /path/samp /path/crmp /path/mta /path/mc;mkdir -p /path/update/cs /path/update/css /path/update/cssold /path/update/csgo /path/update/samp /path/update/crmp /path/update/mta /path/update/mc;cd /path/steam; wget http://media.steampowered.com/client/steamcmd_linux.tar.gz; tar xvfz steamcmd_linux.tar.gz; rm steamcmd_linux.tar.gz;groupmod -g 998 `cat /etc/group | grep :1000 | awk -F":" '{print $1}'`; groupadd -g 1000 servers;chmod 711 /servers;chown root:servers /servers;chmod 711 /servers/cs;chown root:servers /servers/cs;chmod 711 /servers/cssold;chown root:servers /servers/cssold;chmod 711 /servers/css;chown root:servers /servers/css;chmod 711 /servers/csgo;chown root:servers /servers/csgo;chmod 711 /servers/samp;chown root:servers /servers/samp;chmod 711 /servers/crmp;chown root:servers /servers/crmp;chmod 711 /servers/mta;chown root:servers /servers/mta;chmod 711 /servers/mc;chown root:servers /servers/mc;chmod -R 755 /path;chown root:servers /path;chmod -R 750 /copy;chown root:root /copy;chmod -R 750 /etc/proftpd;wget -O proftpd_sqldump $MIRROR/files/debian/proftpd/proftpd_sqldump.txt;mysql -uroot -p${sqlpass} -e \"CREATE DATABASE ftp;\";mysql -uroot -p${sqlpass} -e \"CREATE USER 'ftp'@'localhost' IDENTIFIED BY '${ftpass}';\";mysql -uroot -p${sqlpass} -e \"GRANT ALL PRIVILEGES ON ftp . * TO 'ftp'@'localhost';\";mysql -uroot -p${sqlpass} ftp < proftpd_sqldump;rm -rf proftpd_sqldump;sed -i 's/passwdfor/'${sqlpass}'/g' /etc/proftpd/sql.conf;"
		if [ "${4}" = "1" ]; then
			Installation "${5}" "[16/${max}] Installation Ioncube Loader..." "wget ${MIRROR}/ioncube/ioncube${longbit}.zip; unzip ioncube${longbit}.zip; rm ioncube${longbit}.zip; cp ioncube/ioncube_loader_lin_5.6.so /usr/lib/php5/20131226; sed -i \"3i\zend_extension = /usr/lib/php5/20131226/ioncube_loader_lin_5.6.so\" /etc/php5/apache2/php.ini /etc/php5/cli/php.ini; rm -r ioncube"
		else
			Installation "${5}" "[16/${max}] Installation Ioncube Loader..." "wget ${MIRROR}/ioncube/ioncube${longbit}.zip; unzip ioncube${longbit}.zip; rm ioncube${longbit}.zip; cp ioncube/ioncube_loader_lin_5.6.so /usr/lib/php/20131226; sed -i \"3i\zend_extension = /usr/lib/php/20131226/ioncube_loader_lin_5.6.so\" /etc/php/5.6/apache2/php.ini /etc/php/5.6/cli/php.ini; rm -r ioncube"
		fi
		Installation "${5}" "[22/${max}] Restarting service 'ProFTPD, MySQL, Nginx, Apache2'..." "ln -s /usr/share/phpmyadmin /var/www/pma; rm -r /var/www/html; service proftpd restart; service mysql restart; service nginx restart; service apache2 restart"
		Installation "${5}" "[23/${max}] Saving data..." "wget ${MIRROR}/bspanel.txt -O bspanel.data; sed -i \"s/domain_bsp/${domain}/g\" bspanel.data; sed -i \"s/passwd_mysql/${sqlpass}/g\" bspanel.data; sed -i \"s/passwd_account/${PassGen}/g\" bspanel.data"
	else
		Installation "${5}" "[15/${max}] Configuring BSPanel..." "wget ${MIRROR}/v3/wbspanel.sql; sed -i \"s/mysqlp/${sqlpass}/g\" /var/www/system/data/mysql.php; sed -i \"s/bspanel_domain/${domain}/g\" /var/www/system/data/config.php; sed -i \"s/bspanel_addr/${addr}/g\" /var/www/system/data/config.php; sed -i \"s/key123/${ckey}/g\" /var/www/system/data/config.php; sed -i \"s/bspanel_random_passwd/${PassGen}/g\" /var/www/system/data/config.php; sed -i \"s/bspanel_addr/${addr}/g\" /root/wbspanel.sql; sed -i \"s/bspanel_sshpass/${2}/g\" /root/wbspanel.sql; sed -i \"s/bspanel_accountpass/${newpass}/g\" /root/wbspanel.sql; sed -i \"${addr} ${domain}\" /etc/hosts; mysql -u root -p${sqlpass} -e \"CREATE DATABASE bspanel CHARACTER SET utf8 COLLATE utf8_general_ci;\"; mysql -u root -p${sqlpass} bspanel < wbspanel.sql && rm wbspanel.sql; mysql -u root -p${sqlpass} -e \"SET global sql_mode='NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION';\""	
		unbuffer expect -c "
		spawn mysql_config_editor set --login-path=local --host=localhost --user=root --password
		expect -nocase \"Enter password:\" {send \"${sqlpass}\r\"; interact}" > /dev/null 2>&1
		if [ "${4}" = "1" ]; then
			Installation "${5}" "[16/${max}] Installation Ioncube Loader..." "wget ${MIRROR}/ioncube/ioncube${longbit}.zip; unzip ioncube${longbit}.zip; rm ioncube${longbit}.zip; cp ioncube/ioncube_loader_lin_5.6.so /usr/lib/php5/20131226; sed -i \"3i\zend_extension = /usr/lib/php5/20131226/ioncube_loader_lin_5.6.so\" /etc/php5/apache2/php.ini /etc/php5/cli/php.ini; rm -r ioncube"
		else
			Installation "${5}" "[16/${max}] Installation Ioncube Loader..." "wget ${MIRROR}/ioncube/ioncube${longbit}.zip; unzip ioncube${longbit}.zip; rm ioncube${longbit}.zip; cp ioncube/ioncube_loader_lin_5.6.so /usr/lib/php/20131226; sed -i \"3i\zend_extension = /usr/lib/php/20131226/ioncube_loader_lin_5.6.so\" /etc/php/5.6/apache2/php.ini /etc/php/5.6/cli/php.ini; rm -r ioncube"
		fi
		Installation "${5}" "[17/${max}] Restarting service 'ProFTPD, MySQL, Nginx, Apache2'..." "ln -s /usr/share/phpmyadmin /var/www/pma; rm -r /var/www/html; service proftpd restart; service mysql restart; service nginx restart; service apache2 restart"
		Installation "${5}" "[18/${max}] Saving data..." "wget ${MIRROR}/bspanel.txt -O bspanel.data; sed -i \"s/domain_bsp/${domain}/g\" bspanel.data; sed -i \"s/passwd_mysql/${sqlpass}/g\" bspanel.data; sed -i \"s/passwd_account/${PassGen}/g\" bspanel.data"
	fi


	echo "Завершаем установку ${red}BSPanel${green} на $(lsb_release -si) $(lsb_release -sr)${reset}"
	echo "Спасибо что установили ${red}BSPanel${reset}, данные были сохранены в файле: bspanel.data" && exit
}

settings_bspanel() # by Zalkarbek
{
	clear; max="19"

	Installation "false" "${green}Settings BSPanel...${reset}" "apt-get update && apt-get upgrade -y; apt-get install -y lsb-release"
	Installation "${6}" "${green}Settings BSPanel started...${reset}" "clear"

	if [ "${2}" = "ip" ]; then 
		domain=$addr
	else 
		domain=$2
	fi
	if [ "${1}" = "setting" ]; then
		Installation "${6}" "[1/${max}] Adding packages..." "echo -n > /etc/apt/sources.list; echo \"deb http://ftp.ru.debian.org/debian/ $(lsb_release -sc) main\" > /etc/apt/sources.list; echo \"deb-src http://ftp.ru.debian.org/debian/ $(lsb_release -sc) main\" >> /etc/apt/sources.list; echo \"deb http://security.debian.org/ $(lsb_release -sc)/updates main\" >> /etc/apt/sources.list; echo \"deb-src http://security.debian.org/ $(lsb_release -sc)/updates main\" >> /etc/apt/sources.list; echo \"deb http://ftp.ru.debian.org/debian/ $(lsb_release -sc)-updates main\" >> /etc/apt/sources.list; echo \"deb-src http://ftp.ru.debian.org/debian/ $(lsb_release -sc)-updates main\" >> /etc/apt/sources.list"
		Installation "${6}" "[2/${max}] Updating packages..." "apt-get update && apt-get upgrade -y"
		Installation "${6}" "[3/${max}] Packages installation..." "apt-get install -y apt-transport-https ca-certificates apt-utils pwgen wget dialog cron sudo lsb-release lib32z1 expect nload screen htop nano tcpdump zip unzip mc curl ssh"
		sqlpass=$(pwgen -cns -1 16) ftpass=$(pwgen -cns -1 16)
		if [ "${5}" = "1" ]; then
			Installation "${6}" "[4/${max}] Adding packages for php 5.6..." "apt-get update"
			Installation "${6}" "[5/${max}] Installation PHP 5.6..." "apt-get install -y php5"
			Installation "${6}" "[6/${max}] Installation packages PHP..." "apt-get install -y php5-dev php5-zip php5-gd php5-curl php5-json php5-xml php5-mbstring php5-mysql libapache2-mod-php5 php5-ssh2 php-pclzip php-pear bc"
		else
			Installation "${6}" "[4/${max}] Adding packages for php 5.6..." "wget https://packages.sury.org/php/apt.gpg -O /etc/apt/trusted.gpg.d/php.gpg; sh -c 'echo \"deb https://packages.sury.org/php/ $(lsb_release -sc) main\" > /etc/apt/sources.list.d/php.list'; apt-get update"
			Installation "${6}" "[5/${max}] Installation PHP 5.6..." "apt-get install -y php5.6"
			Installation "${6}" "[6/${max}] Installation packages PHP..." "apt-get install -y php5.6-dev php5.6-zip php5.6-gd php5.6-curl php5.6-memcache php5.6-memcached memcached php5.6-json php5.6-xml php5.6-mbstring php5.6-mysql libapache2-mod-php5.6 php5.6-ssh2 php-pclzip php-pear"
		fi
		Installation "${6}" "[7/${max}] Installation Apache2..." "apt-get install -y apache2"
		Installation "${6}" "[8/${max}] Installation MySQL 5.6..." "wget https://dev.mysql.com/get/mysql-apt-config_0.8.14-1_all.deb; export DEBIAN_FRONTEND=noninteractive; echo mysql-apt-config mysql-apt-config/select-server select mysql-5.6 | debconf-set-selections; echo mysql-apt-config mysql-apt-config/select-product select Ok | debconf-set-selections; dpkg -i mysql-apt-config_0.8.14-1_all.deb && rm mysql-apt-config_0.8.14-1_all.deb; echo mysql-community-server mysql-community-server/root-pass password \"${sqlpass}\" | debconf-set-selections; echo mysql-community-server mysql-community-server/re-root-pass password \"${sqlpass}\" | debconf-set-selections; apt-get update; apt-get install -y mysql-server"
		Installation "${6}" "[9/${max}] Installation phpMyAdmin..." "echo \"phpmyadmin phpmyadmin/dbconfig-install boolean true\" | debconf-set-selections; echo \"phpmyadmin phpmyadmin/mysql/admin-user string root\" | debconf-set-selections; echo \"phpmyadmin phpmyadmin/mysql/admin-pass password ${sqlpass}\" | debconf-set-selections; echo \"phpmyadmin phpmyadmin/mysql/app-pass password ${sqlpass}\" | debconf-set-selections; echo \"phpmyadmin phpmyadmin/app-password-confirm password ${sqlpass}\" | debconf-set-selections; echo 'phpmyadmin phpmyadmin/reconfigure-webserver multiselect apache2' | debconf-set-selections; apt-get install -y phpmyadmin"
		Installation "${6}" "[10/${max}] Creating virtualhost Apache2..." "cd /etc/apache2/sites-available; sed -i \"/Listen 80/d\" *; echo \"Listen 80\">${apache2}; echo \"<VirtualHost *:80>\">${apache2}; echo \"	ServerName ${domain}\">>${apache2}; echo \"	DocumentRoot /var/www\">>${apache2}; echo \"	<Directory /var/www/>\">>${apache2}; echo \"	Options Indexes FollowSymLinks MultiViews\">>${apache2}; echo \"	AllowOverride All\">>${apache2}; echo \"	Order allow,deny\">>${apache2}; echo \"	allow from all\">>${apache2}; echo \"	</Directory>\">>${apache2}; echo \"	ErrorLog \${APACHE_LOG_DIR}/error.log\">>${apache2}; echo \"	LogLevel warn\">>${apache2}; echo \"	CustomLog \${APACHE_LOG_DIR}/access.log combined\">>${apache2}; echo \"</VirtualHost>\">>${apache2}"
		Installation "${6}" "[11/${max}] Enabling module Apache2 and Restarting service Apache2..." "a2enconf bspanel.conf; systemctl reload apache2; a2enmod php5.6; a2enmod rewrite; service apache2 restart"
		if [ "${5}" = "1" ]; then
			Installation "${6}" "[14/${max}] Configuring time..." "timedatectl set-timezone Europe/Moscow; dpkg-reconfigure tzdata -f noninteractive; sed -i -r 's~^;date\.timezone =$~date.timezone = \"Europe/Moscow\"~' /etc/php5/cli/php.ini; sed -i -r 's~^;date\.timezone =$~date.timezone = \"Europe/Moscow\"~' /etc/php5/apache2/php.ini"
		else
			Installation "${6}" "[14/${max}] Configuring time..." "timedatectl set-timezone Europe/Moscow; dpkg-reconfigure tzdata -f noninteractive; sed -i -r 's~^;date\.timezone =$~date.timezone = \"Europe/Moscow\"~' /etc/php/5.6/cli/php.ini; sed -i -r 's~^;date\.timezone =$~date.timezone = \"Europe/Moscow\"~' /etc/php/5.6/apache2/php.ini"
		fi
		unbuffer expect -c "
		spawn mysql_config_editor set --login-path=local --host=localhost --user=root --password
		expect -nocase \"Enter password:\" {send \"${sqlpass}\r\"; interact}" > /dev/null 2>&1
		Installation "${6}" "[13/${max}] Required packages for the server side..." "serivce apache2 stop; apt-get install -y ethstatus qstat gdb lib32gcc1 gcc-multilib lib32stdc++6 libreadline5 ntpdate lsof; sudo dpkg --add-architecture i386"
		Installation "${6}" "[17/${max}] Installation Java 8..." "wget ${MIRROR}/v3/rep/jre-linux.tar.gz; tar xvfz jre-linux.tar.gz; mkdir /usr/lib/jvm; mv jre1.8.0_45 /usr/lib/jvm/jre1.8.0_45; update-alternatives --install /usr/bin/java java /usr/lib/jvm/jre1.8.0_45/bin/java 1; update-alternatives --config java && rm jre-linux.tar.gz"
		Installation "${6}" "[15/${max}] Installation and configure 'iptables, rclocal, geoip'..." "wget -O rclocal ${MIRROR}/files/debian/rclocal/rclocal.txt; sed -i '14d' /etc/rc.local; cat rclocal >> /etc/rc.local && touch /root/iptables_block; echo \"UseDNS no\" >> /etc/ssh/sshd_config && echo \"UTC=no\" >> /etc/default/rcS; rm -rf rclocal; sudo apt-get --yes --force-yes install xtables-addons-common; sudo apt-get --yes --force-yes install libtext-csv-xs-perl libxml-csv-perl libtext-csv-perl unzip; sudo mkdir -p /usr/share/xt_geoip/; mkdir geoiptmp; cd geoiptmp /usr/lib/xtables-addons/xt_geoip_dl; sudo /usr/lib/xtables-addons/xt_geoip_build GeoIPv6.csv GeoIPCountryWhois.csv -D /usr/share/xt_geoip; cd && rm -rf geoiptmp"
		Installation "${6}" "[16/${max}] Installation Nginx..." "rm nginx; wget -O nginx $MIRROR/files/debian/nginx/nginx.txt; service apache2 stop; apt-get install -y nginx; mkdir -p /var/nginx/; rm -rf /etc/nginx/nginx.conf; mv nginx /etc/nginx/nginx.conf; service nginx restart; service apache2 start; rm -rf nginx"
		Installation "${6}" "[17/${max}] Installation and configure ProFTPD..." "wget -O proftpd $MIRROR/files/debian/proftpd/proftpd.txt;wget -O proftpd_modules $MIRROR/files/debian/proftpd/proftpd_modules.txt;wget -O proftpd_sql $MIRROR/files/debian/proftpd/proftpd_sql.txt;echo PURGE | debconf-communicate proftpd-basic;echo proftpd-basic shared/proftpd/inetd_or_standalone select standalone | debconf-set-selections;apt-get install -y proftpd-basic proftpd-mod-mysql;rm -rf /etc/proftpd/proftpd.conf/etc/proftpd/modules.conf /etc/proftpd/sql.conf;mv proftpd /etc/proftpd/proftpd.conf;mv proftpd_modules /etc/proftpd/modules.conf;mv proftpd_sql /etc/proftpd/sql.conf;rm -rf proftpd proftpd_modules proftpd_sql;mkdir -p /copy /servers /servers/cs /servers/cssold /servers/css /servers/csgo /servers/samp /servers/crmp /servers/mta /servers/mc /path/steam /var/nginx;mkdir -p /path/cs /path/css /path/cssold /path/csgo /path/samp /path/crmp /path/mta /path/mc;mkdir -p /path/update/cs /path/update/css /path/update/cssold /path/update/csgo /path/update/samp /path/update/crmp /path/update/mta /path/update/mc;cd /path/steam; wget http://media.steampowered.com/client/steamcmd_linux.tar.gz; tar xvfz steamcmd_linux.tar.gz; rm steamcmd_linux.tar.gz;groupmod -g 998 `cat /etc/group | grep :1000 | awk -F":" '{print $1}'`; groupadd -g 1000 servers;chmod 711 /servers;chown root:servers /servers;chmod 711 /servers/cs;chown root:servers /servers/cs;chmod 711 /servers/cssold;chown root:servers /servers/cssold;chmod 711 /servers/css;chown root:servers /servers/css;chmod 711 /servers/csgo;chown root:servers /servers/csgo;chmod 711 /servers/samp;chown root:servers /servers/samp;chmod 711 /servers/crmp;chown root:servers /servers/crmp;chmod 711 /servers/mta;chown root:servers /servers/mta;chmod 711 /servers/mc;chown root:servers /servers/mc;chmod -R 755 /path;chown root:servers /path;chmod -R 750 /copy;chown root:root /copy;chmod -R 750 /etc/proftpd;wget -O proftpd_sqldump $MIRROR/files/debian/proftpd/proftpd_sqldump.txt;mysql -uroot -p${sqlpass} -e \"CREATE DATABASE ftp;\";mysql -uroot -p${sqlpass} -e \"CREATE USER 'ftp'@'localhost' IDENTIFIED BY '${ftpass}';\";mysql -uroot -p${sqlpass} -e \"GRANT ALL PRIVILEGES ON ftp . * TO 'ftp'@'localhost';\";mysql -uroot -p${sqlpass} ftp < proftpd_sqldump;rm -rf proftpd_sqldump;sed -i 's/passwdfor/'${sqlpass}'/g' /etc/proftpd/sql.conf;"
		Installation "${6}" "[18/${max}] Restarting service 'ProFTPD, MySQL, Nginx, Apache2'..." "ln -s /usr/share/phpmyadmin /var/www/pma; rm -r /var/www/html; service proftpd restart; service mysql restart; service nginx restart; service apache2 restart"
		Installation "${6}" "[19/${max}] Saving data..." "wget ${MIRROR}/bspanel_settings.txt; sed -i \"s/passwd_mysql/${sqlpass}/g\" bspanel_settings.txt; cat bspanel_settings.txt >> bspanel.data; rm bspanel_settings.txt"
	else
		sqlpass=$4 ftpass=$(pwgen -cns -1 16); max=8
		Installation "${6}" "[1/${max}] Configuring BSPanel..." "wget ${MIRROR}/v3/sbspanel.sql; sed -i \"s/bspanel_addr/${addr}/g\" /var/www/system/data/web.php; sed -i \"s/bspanel_sshpass/${3}/g\" /var/www/system/data/web.php; sed -i \"s/bspanel_domain/${domain}/g\" /var/www/system/data/web.php; sed -i \"s/bspanel_domain/${domain}/g\" /root/sbspanel.sql; sed -i \"s/bspanel_addr/${addr}/g\" /root/sbspanel.sql; sed -i \"s/bspanel_sqlpass/${sqlpass}/g\" /root/sbspanel.sql; sed -i \"s/bspanel_sshpass/${3}/g\" /root/sbspanel.sql; sed -i \"${addr} ${domain}\" /etc/hosts; mysql -u root -p${sqlpass} -Dbspanel -e \"DROP TABLE units;\"; mysql -u root -p${sqlpass} bspanel < sbspanel.sql && rm sbspanel.sql;"
		Installation "${6}" "[2/${max}] Required packages for the server side..." "serivce apache2 stop; apt-get install -y ethstatus qstat gdb lib32gcc1 gcc-multilib lib32stdc++6 libreadline5 ntpdate lsof; sudo dpkg --add-architecture i386"
		Installation "${6}" "[17/${max}] Installation Java 8..." "wget ${MIRROR}/v3/rep/jre-linux.tar.gz; tar xvfz jre-linux.tar.gz; mkdir /usr/lib/jvm; mv jre1.8.0_45 /usr/lib/jvm/jre1.8.0_45; update-alternatives --install /usr/bin/java java /usr/lib/jvm/jre1.8.0_45/bin/java 1; update-alternatives --config java && rm jre-linux.tar.gz"
		Installation "${6}" "[4/${max}] Installation and configure 'iptables, rclocal, geoip'..." "wget -O rclocal ${MIRROR}/files/debian/rclocal/rclocal.txt; sed -i '14d' /etc/rc.local; cat rclocal >> /etc/rc.local && touch /root/iptables_block; echo \"UseDNS no\" >> /etc/ssh/sshd_config && echo \"UTC=no\" >> /etc/default/rcS; rm -rf rclocal; sudo apt-get --yes --force-yes install xtables-addons-common; sudo apt-get --yes --force-yes install libtext-csv-xs-perl libxml-csv-perl libtext-csv-perl unzip; sudo mkdir -p /usr/share/xt_geoip/; mkdir geoiptmp; cd geoiptmp /usr/lib/xtables-addons/xt_geoip_dl; sudo /usr/lib/xtables-addons/xt_geoip_build GeoIPv6.csv GeoIPCountryWhois.csv -D /usr/share/xt_geoip; cd && rm -rf geoiptmp"
		Installation "${6}" "[5/${max}] Installation Nginx..." "rm nginx; wget -O nginx $MIRROR/files/debian/nginx/nginx.txt; service apache2 stop; apt-get install -y nginx; mkdir -p /var/nginx/; rm -rf /etc/nginx/nginx.conf; mv nginx /etc/nginx/nginx.conf; service nginx restart; service apache2 start; rm -rf nginx"
		Installation "${6}" "[6/${max}] Installation and configure ProFTPD..." "wget -O proftpd $MIRROR/files/debian/proftpd/proftpd.txt;wget -O proftpd_modules $MIRROR/files/debian/proftpd/proftpd_modules.txt;wget -O proftpd_sql $MIRROR/files/debian/proftpd/proftpd_sql.txt;echo PURGE | debconf-communicate proftpd-basic;echo proftpd-basic shared/proftpd/inetd_or_standalone select standalone | debconf-set-selections;apt-get install -y proftpd-basic proftpd-mod-mysql;rm -rf /etc/proftpd/proftpd.conf/etc/proftpd/modules.conf /etc/proftpd/sql.conf;mv proftpd /etc/proftpd/proftpd.conf;mv proftpd_modules /etc/proftpd/modules.conf;mv proftpd_sql /etc/proftpd/sql.conf;rm -rf proftpd proftpd_modules proftpd_sql;mkdir -p /copy /servers /servers/cs /servers/cssold /servers/css /servers/csgo /servers/samp /servers/crmp /servers/mta /servers/mc /path/steam /var/nginx;mkdir -p /path/cs /path/css /path/cssold /path/csgo /path/samp /path/crmp /path/mta /path/mc;mkdir -p /path/update/cs /path/update/css /path/update/cssold /path/update/csgo /path/update/samp /path/update/crmp /path/update/mta /path/update/mc;cd /path/steam; wget http://media.steampowered.com/client/steamcmd_linux.tar.gz; tar xvfz steamcmd_linux.tar.gz; rm steamcmd_linux.tar.gz;groupmod -g 998 `cat /etc/group | grep :1000 | awk -F":" '{print $1}'`; groupadd -g 1000 servers;chmod 711 /servers;chown root:servers /servers;chmod 711 /servers/cs;chown root:servers /servers/cs;chmod 711 /servers/cssold;chown root:servers /servers/cssold;chmod 711 /servers/css;chown root:servers /servers/css;chmod 711 /servers/csgo;chown root:servers /servers/csgo;chmod 711 /servers/samp;chown root:servers /servers/samp;chmod 711 /servers/crmp;chown root:servers /servers/crmp;chmod 711 /servers/mta;chown root:servers /servers/mta;chmod 711 /servers/mc;chown root:servers /servers/mc;chmod -R 755 /path;chown root:servers /path;chmod -R 750 /copy;chown root:root /copy;chmod -R 750 /etc/proftpd;wget -O proftpd_sqldump $MIRROR/files/debian/proftpd/proftpd_sqldump.txt;mysql -uroot -p${sqlpass} -e \"CREATE DATABASE ftp;\";mysql -uroot -p${sqlpass} -e \"CREATE USER 'ftp'@'localhost' IDENTIFIED BY '${ftpass}';\";mysql -uroot -p${sqlpass} -e \"GRANT ALL PRIVILEGES ON ftp . * TO 'ftp'@'localhost';\";mysql -uroot -p${sqlpass} ftp < proftpd_sqldump;rm -rf proftpd_sqldump;sed -i 's/passwdfor/'${sqlpass}'/g' /etc/proftpd/sql.conf;"
		Installation "${6}" "[7/${max}] Restarting service 'ProFTPD, MySQL, Nginx, Apache2'..." "ln -s /usr/share/phpmyadmin /var/www/pma; rm -r /var/www/html; service proftpd restart; service mysql restart; service nginx restart; service apache2 restart"
		Installation "${6}" "[8/${max}] Saving data..." "wget ${MIRROR}/bspanel_settings.txt; sed -i \"s/passwd_mysql/${sqlpass}/g\" bspanel_settings.txt; cat bspanel_settings.txt >> bspanel.data; rm bspanel_settings.txt"
	fi
	echo "Завершаем настройку локации ${red}BSPanel${green} на $(lsb_release -si) $(lsb_release -sr)${reset}"
	echo "Спасибо что установили ${red}BSPanel${reset}, данные были сохранены в файле: bspanel.data" && exit
}

install_games()
{
	clear
	wow
	Info "• —————————————————————————— Список доступных игр —————————————————————————— •"
	Info "• 1 → SteamCMD - обязательно для [CSS, CSGO]"
	Info "• 2 → Counter-Strike: 1.6"
	Info "• 3 → Counter-Strike: Source"
	Info "• 4 → Counter-Strike: Source v34"
	Info "• 5 → Counter-Strike: Global Offensive"
	Info "• 6 → Multi Theft Auto"
	Info "• 7 → San Andreas Multiplayer"
	Info "• 8 → Crminal Russia Multiplayer"
	Info "• 9 → Minecraft"
	Info "• —————————————————————————————————————————————————————————————————————————— •"
	Info "• 0 → В главное меню"
	wow1
	Info
	read -p "Пожалуйста, введите пункт меню: " case
	case $case in
		1)Installation "false" "Installation Steam" "wget -P /path/steam http://media.steampowered.com/client/steamcmd_linux.tar.gz; cd /path/steam; tar xvzf steamcmd_linux.tar.gz; rm steamcmd_linux.tar.gz"; sleep 2; install_games;;
		2)clear
			Info "Counter-Strike 1.6"
			Info "------------------"
			Info "• ${red}1${green} → ReHLDS"
			Info "• ${red}2${green} → 7559"
			Info "• ${red}3${green} → 6153"
			Info "• ${red}4${green} → 5787"
			Info "------------------"
			Info "• ${red}5${green} → Все"
			Info "------------------"
			Info "• ${red}0${green} → Меню"
			read -p "Пожалуйста, введите пункт меню: " build
			case $build in
				1)Installation "false" "Installation game Counter-Strike 1.6: ReHLDS..." "rm -r /path/cs/rehlds; wget -P /path/cs/rehlds ${MIRROR}/path/cs/rehlds.zip; cd /path/cs/rehlds; unzip rehlds.zip; rm rehlds.zip"; sleep 2; install_games;;
				2)Installation "false" "Installation game Counter-Strike 1.6: 7559..." "rm -r /path/cs/7559; wget -P /path/cs/7559 ${MIRROR}/path/cs/7559.zip; cd /path/cs/7559; unzip 7559.zip; rm 7559.zip"; sleep 2; install_games;;
				3)Installation "false" "Installation game Counter-Strike 1.6: 6153..." "rm -r /path/cs/6153; wget -P /path/cs/6153 ${MIRROR}/path/cs/6153.zip; cd /path/cs/6153; unzip 6153.zip; rm 6153.zip"; sleep 2; install_games;;
				4)Installation "false" "Installation game Counter-Strike 1.6: 5787..." "rm -r /path/cs/5787; wget -P /path/cs/5787 ${MIRROR}/path/cs/5787.zip; cd /path/cs/5787; unzip 5787.zip; rm 5787.zip"; sleep 2; install_games;;
				5)Installation "false" "Installation game Counter-Strike 1.6 all version" "rm -r /path/cs/rehlds; wget -P /path/cs/rehlds ${MIRROR}/path/cs/rehlds.zip; cd /path/cs/rehlds; unzip rehlds.zip; rm rehlds.zip;rm -r /path/cs/7559; wget -P /path/cs/7559 ${MIRROR}/path/cs/7559.zip; cd /path/cs/7559; unzip 7559.zip; rm 7559.zip;rm -r /path/cs/6153; wget -P /path/cs/6153 ${MIRROR}/path/cs/6153.zip; cd /path/cs/6153; unzip 6153.zip; rm 6153.zip;rm -r /path/cs/5787; wget -P /path/cs/5787 ${MIRROR}/path/cs/5787.zip; cd /path/cs/5787; unzip 5787.zip; rm 5787.zip"; sleep 2; install_games;;
				0)install_games;;
			esac;;
		3)clear
			echo "1 → Да, 0 → Нет"
			read -p "Подтверждение установки: " confirm
			if [ $confirm = "0" ]; then install_games; fi
			if [ -f "/path/steam/steamcmd.sh" ]; then
				Installation "false" "Installation game Counter-Strike: Source..." "rm -r /path/css; cd /path/steam; ./steamcmd.sh +login anonymous +force_install_dir /path/css/steam/ +app_update 232330 validate +quit"; sleep 2; install_games
			else
				Installation "false" "Installation Steam..." "wget -P /path/steam http://media.steampowered.com/client/steamcmd_linux.tar.gz; cd /path/steam; tar xvzf steamcmd_linux.tar.gz; rm steamcmd_linux.tar.gz"
				Installation "false" "Installation game Counter-Strike: Source..." "rm -r /path/css/steam; cd /path/steam; ./steamcmd.sh +login anonymous +force_install_dir /path/css/steam/ +app_update 232330 validate +quit"; sleep 2; install_games
			fi;;
		4)clear
			echo "1 → Да, 0 → Нет"
			read -p "Подтверждение установки: " confirm
			if [ $confirm = "0" ]; then install_games; fi
			Installation "false" "Installation game Counter-Strike: Source v34" "rm -r /path/cssold; wget -P /path/cssold ${MIRROR}/path/cssold/cssold.zip; cd /path/cssold; unzip cssold.zip; rm cssold.zip"; sleep 2; install_games;;
		5)clear
			echo "1 → Да, 0 → Нет"
			read -p "Подтверждение установки: " confirm
			if [ $confirm = "0" ]; then install_games; fi
			if [ -f "/path/steam/steamcmd.sh" ]; then
				Installation "false" "Installation game Counter-Strike: Global Offensive..." "rm -r /path/csgo/*; cd /path/steam; ./steamcmd.sh +login anonymous +force_install_dir /path/csgo/ +app_update 740 validate +quit"; sleep 2; install_games
			else
				Installation "false" "Installation Steam..." "wget -P /path/steam http://media.steampowered.com/client/steamcmd_linux.tar.gz; cd /path/steam; tar xvzf steamcmd_linux.tar.gz; rm steamcmd_linux.tar.gz"
				Installation "false" "Installation game Counter-Strike: Global Offensive..." "rm -r /path/csgo/*; cd /path/steam; ./steamcmd.sh +login anonymous +force_install_dir /path/csgo/ +app_update 740 validate +quit"; sleep 2; install_games
			fi;;
		6)clear
			Info "Multi Theft Auto"
			Info "----------------"
			Info "• ${red}1${green} → 1.5.5-R2"
			Info "• ${red}2${green} → 1.5.4-R3"
			Info "----------------"
			Info "• ${red}3${green} → Все"
			Info "----------------"
			Info "• ${red}0${green} → Меню"
			read -p "Пожалуйста, введите пункт меню: " version
			case $version in
				1)Installation "false" "Installation game MTA v1.5.5-R2" "rm -r /path/mta/mta155; wget -P /path/mta/mta155 ${MIRROR}/path/mta/155.zip; cd /path/mta/mta155; unzip 155.zip; rm 155.zip"; sleep 2; install_games;;
				2)Installation "false" "Installation game MTA v1.5.4-R3" "rm -r /path/mta/mta154; wget -P /path/mta/mta154 ${MIRROR}/path/mta/154.zip; cd /path/mta/mta154; unzip 154.zip; rm 154.zip"; sleep 2; install_games;;
				3)Installation "false" "Installation game MTA all version" "rm -r /path/mta/mta155; wget -P /path/mta/mta155 ${MIRROR}/path/mta/155.zip; cd /path/mta/mta155; unzip 155.zip; rm 155.zip; rm -r /path/mta/mta154; wget -P /path/mta/mta154 ${MIRROR}/path/mta/154.zip; cd /path/mta/mta154; unzip 154.zip; rm 154.zip"; sleep 2; install_games;;
				0)install_games;;
			esac;;
		7)clear
			Info "San Andreas Multiplayer"
			Info "-----------------------"
			Info "• ${red}1${green} → 0.3.7-R2"
			Info "• ${red}2${green} → 0.3e-R2"
			Info "-----------------------"
			Info "• ${red}3${green} → Все"
			Info "-----------------------"
			Info "• ${red}0${green} → Меню"
			read -p "Пожалуйста, введите пункт меню: " version
			case $version in
				1)Installation "false" "Installation game SAMP v0.3.7-R2" "rm -r /path/samp/037; wget -P /path/samp/037 ${MIRROR}/path/samp/037.zip; cd /path/samp/037; unzip 037.zip; rm 037.zip"; sleep 2; install_games;;
				2)Installation "false" "Installation game SAMP v0.3e-R2" "rm -r /path/samp/03e; wget -P /path/samp/03e ${MIRROR}/path/samp/03e.zip; cd /path/samp/03e; unzip 03e.zip; rm 03e.zip"; sleep 2; install_games;;
				3)Installation "false" "Installation game SAMP all version" "rm -r /path/samp/037; wget -P /path/samp/037 ${MIRROR}/path/samp/037.zip; cd /path/samp/037; unzip 037.zip; rm 037.zip;rm -r /path/samp/03e; wget -P /path/samp/03e ${MIRROR}/path/samp/03e.zip; cd /path/samp/03e; unzip 03e.zip; rm 03e.zip"; sleep 2; install_games;;
				0)install_games;;
			esac;;
		8)clear
			Info "Criminal Russia Multiplayer"
			Info "---------------------------"
			Info "• ${red}1${green} → 0.3.7-C5"
			Info "• ${red}2${green} → 0.3e-C3"
			Info "---------------------------"
			Info "• ${red}3${green} → Все"
			Info "---------------------------"
			Info "• ${red}0${green} → Меню"
			read -p "Пожалуйста, введите пункт меню: " version
			case $version in
				1)Installation "false" "Installation game CRMP v0.3.7-C5" "rm -r /path/samp/037; wget -P /path/crmp/037 ${MIRROR}/path/crmp/037.zip; cd /path/crmp/037; unzip 037.zip; rm 037.zip"; sleep 2; install_games;;
				2)Installation "false" "Installation game CRMP v0.3e-C3" "rm -r /path/samp/03e; wget -P /path/crmp/03e ${MIRROR}/path/crmp/03e.zip; cd /path/crmp/03e; unzip 03e.zip; rm 03e.zip"; sleep 2; install_games;;
				3)Installation "false" "Installation game CRMP all version" "rm -r /path/samp/037; wget -P /path/crmp/037 ${MIRROR}/path/crmp/037.zip; cd /path/crmp/037; unzip 037.zip; rm 037.zip;rm -r /path/samp/03e; wget -P /path/crmp/03e ${MIRROR}/path/crmp/03e.zip; cd /path/crmp/03e; unzip 03e.zip; rm 03e.zip"; sleep 2; install_games;;
				0)install_games;;
			esac;;
		9)clear
			Info "Minecraft"
			Info "---------"
			Info "• ${red}1${green} → 1.12-R0"
			Info "• ${red}2${green} → 1.11.2-R0"
			Info "• ${red}3${green} → 1.11-R0"
			Info "• ${red}4${green} → 1.10.2-R0"
			Info "• ${red}5${green} → 1.8.5-R0"
			Info "• ${red}6${green} → 1.8-R0"
			Info "• ${red}7${green} → 1.7.9-R0"
			Info "• ${red}8${green} → 1.6.4-R0"
			Info "---------"
			Info "• ${red}9${green} → Все"
			Info "---------"
			Info "• ${red}0${green} → Меню"
			read -p "Пожалуйста, введите пункт меню: " version
			case $version in
				1)Installation "false" "Installation game Minecraft CraftBukkit v1.12-R0" "rm -r /path/mc/1.12; wget -P /path/mc/1.12 ${MIRROR}/path/mc/1.12.zip; cd /path/mc/1.12; unzip 1.12.zip; rm 1.12.zip"; sleep 2; install_games;;
				2)Installation "false" "Installation game Minecraft CraftBukkit v1.11.2-R0" "rm -r /path/mc/1.11.2; wget -P /path/mc/1.11.2 ${MIRROR}/path/mc/1.11.2.zip; cd /path/mc/1.11.2; unzip 1.11.2.zip; rm 1.11.2.zip"; sleep 2; install_games;;
				3)Installation "false" "Installation game Minecraft CraftBukkit v1.11-R0" "rm -r /path/mc/1.11; wget -P /path/mc/1.11 ${MIRROR}/path/mc/1.11.zip; cd /path/mc/1.11; unzip 1.11.zip; rm 1.11.zip"; sleep 2; install_games;;
				4)Installation "false" "Installation game Minecraft CraftBukkit v1.10.2-R0" "rm -r /path/mc/1.10.2; wget -P /path/mc/1.10.2 ${MIRROR}/path/mc/1.10.2.zip; cd /path/mc/1.10.2; unzip 1.10.2.zip; rm 1.10.2.zip"; sleep 2; install_games;;
				5)Installation "false" "Installation game Minecraft CraftBukkit v1.8.5-R0" "rm -r /path/mc/1.8.5; wget -P /path/mc/1.8.5 ${MIRROR}/path/mc/1.8.5.zip; cd /path/mc/1.8.5; unzip 1.8.5.zip; rm 1.8.5.zip"; sleep 2; install_games;;
				6)Installation "false" "Installation game Minecraft CraftBukkit v1.8-R0" "rm -r /path/mc/1.8; wget -P /path/mc/1.8 ${MIRROR}/path/mc/1.8.zip; cd /path/mc/1.8; unzip 1.8.zip; rm 1.8.zip"; sleep 2; install_games;;
				7)Installation "false" "Installation game Minecraft craftbukkit v1.7.9-R0" "rm -r /path/mc/1.7.9; wget -P /path/mc/1.7.9 ${MIRROR}/path/mc/1.7.9.zip; cd /path/mc/1.7.9; unzip 1.7.9.zip; rm 1.7.9.zip"; sleep 2; install_games;;
				8)Installation "false" "Installation game Minecraft CraftBukkit v1.6.4-R0" "rm -r /path/mc/1.6.4; wget -P /path/mc/1.6.4 ${MIRROR}/path/mc/1.6.4.zip; cd /path/mc/1.6.4; unzip 1.6.4.zip; rm 1.6.4.zip"; sleep 2; install_games;;
				9)Installation "false" "Installation game Minecraft all version" "rm -r /path/mc/1.12; wget -P /path/mc/1.12 ${MIRROR}/path/mc/1.12.zip; cd /path/mc/1.12; unzip 1.12.zip; rm 1.12.zip;rm -r /path/mc/1.11.2; wget -P /path/mc/1.11.2 ${MIRROR}/path/mc/1.11.2.zip; cd /path/mc/1.11.2; unzip 1.11.2.zip; rm 1.11.2.zip;rm -r /path/mc/1.11; wget -P /path/mc/1.11 ${MIRROR}/path/mc/1.11.zip; cd /path/mc/1.11; unzip 1.11.zip; rm 1.11.zip;rm -r /path/mc/1.10.2; wget -P /path/mc/1.10.2 ${MIRROR}/path/mc/1.10.2.zip; cd /path/mc/1.10.2; unzip 1.10.2.zip; rm 1.10.2.zip;rm -r /path/mc/1.8; wget -P /path/mc/1.8 ${MIRROR}/path/mc/1.8.zip; cd /path/mc/1.8; unzip 1.8.zip; rm 1.8.zip;rm -r /path/mc/1.7.9; wget -P /path/mc/1.7.9 ${MIRROR}/path/mc/1.7.9.zip; cd /path/mc/1.7.9; unzip 1.7.9.zip; rm 1.7.9.zip;rm -r /path/mc/1.7.9; wget -P /path/mc/1.7.9 ${MIRROR}/path/mc/1.7.9.zip; cd /path/mc/1.7.9; unzip 1.7.9.zip; rm 1.7.9.zip;rm -r /path/mc/1.6.4; wget -P /path/mc/1.6.4 ${MIRROR}/path/mc/1.6.4.zip; cd /path/mc/1.6.4; unzip 1.6.4.zip; rm 1.6.4.zip"; sleep 2; install_games;;
				0)install_games;;
			esac;;
		0) menu;;
	esac
}

install_web()
{	
	clear
	Info "Список доступных Веб модулей"
	Info "----------------------------"
	Info "• ${red}1${green} → CS:Bans"
	Info "• ${red}2${green} → CS:Stats"
	Info "• ${red}3${green} → A:Stats"
	Info "• ${red}4${green} → BuyPrivileges"
	Info "• ${red}5${green} → SourceBans"
	Info "• ${red}6${green} → Поддомен для MySQL [db.site.ru]"
	Info "----------------------------"
	Info "• ${red}7${green} → Все"
	Info "----------------------------"
	Info "• ${red}0${green} → Меню"
	read -p "Пожалуйста, введите пункт меню: " case
	case $case in
	1) 
		echo "1 → Подтвердить, 0 → Нет"
		read -p "Подтверждение: " confirm
		if [ $confirm = "0" ]; then install_web; fi
		Installation "false" "Installation CS:Bans" "cd /path/web; wget ${MIRROR}/v3/web/csbans.zip; unzip csbans.zip && rm csbans.zip"; sleep 2; install_web;;
	2)
		echo "1 → Подтвердить, 0 → Нет"
		read -p "Подтверждение: " confirm
		if [ $confirm = "0" ]; then install_web; fi
		Installation "false" "Installation CS:Stats" "cd /path/web; wget ${MIRROR}/v3/web/csstats.zip; unzip csstats.zip && rm csstats.zip"; sleep 2; install_web;;
	3)
		echo "1 → Подтвердить, 0 → Нет"
		read -p "Подтверждение: " confirm
		if [ $confirm = "0" ]; then install_web; fi
		Installation "false" "Installation A:Stats" "cd /path/web; wget ${MIRROR}/v3/web/astats.zip; unzip astats.zip && rm astats.zip"; sleep 2; install_web;;
	
	4)
		echo "1 → Подтвердить, 0 → Нет"
		read -p "Подтверждение: " confirm
		if [ $confirm = "0" ]; then install_web; fi
		Installation "false" "Installation BuyPrivileges" "cd /path/web; wget ${MIRROR}/v3/web/bp.zip; unzip bp.zip && rm bp.zip"; sleep 2; install_web;;
	5)
		echo "1 → Подтвердить, 0 → Нет"
		read -p "Подтверждение: " confirm
		if [ $confirm = "0" ]; then install_web; fi
		Installation "false" "Installation SourceBans" "cd /path/web; wget ${MIRROR}/v3/web/sourcebans.zip; unzip sourcebans.zip && rm sourcebans.zip"; sleep 2; install_web;;
	
	6)
		read -p "${CYAN}Пожалуйста, введите ${red}домен${CYAN}: ${yellow}" DOMAIN

		if [ -z "${DOMAIN}" ]; then
			echo "${green}• Пожалуйста, заполните ${CYAN}${red}*${CYAN} ${green}обязательное поле${CYAN}"
			read -p "${CYAN}Пожалуйста, введите ${red}домен${CYAN}: ${yellow}" DOMAIN
		fi

		if [ -z "${DOMAIN}" ]; then
			install_web
		fi

		echo "1 → Подтвердить, 0 → Нет"
		read -p "Подтверждение: " confirm
		if [ $confirm = "0" ]; then install_web; fi

		FILE='/etc/apache2/sites-available/db.conf';
		Installation "false" "Configuring MySQL subdomain" "mkdir -p /var/www/db;a2dissite db.conf;echo \"<VirtualHost *:80>\">${FILE}; echo \"	ServerName db.${DOMAIN}\">>${FILE};echo \"	DocumentRoot /var/www/db\">>${FILE};echo \"	<Directory /var/www/db/>\">>${FILE};echo \"	Options Indexes FollowSymLinks MultiViews\">>${FILE};echo \"	AllowOverride All\">>${FILE};echo \"	Order allow,deny\">>${FILE};echo \"	allow from all\">>${FILE};echo \"	</Directory>\">>${FILE};echo \"	ErrorLog \${APACHE_LOG_DIR}/error.log\">>${FILE};echo \"	LogLevel warn\">>${FILE};echo \"	CustomLog \${APACHE_LOG_DIR}/access.log combined\">>${FILE};echo \"</VirtualHost>\">>${FILE};a2ensite db.conf;service apache2 restart;ln -s /usr/share/phpmyadmin/* /var/www/db"; sleep 2; install_web;;
	7) 
		read -p "${CYAN}Пожалуйста, введите ${red}домен${reset}: ${yellow}" DOMAIN

		if [ -z "${DOMAIN}" ]; then
			echo "${green}• Пожалуйста, заполните ${CYAN}${red}*${CYAN} ${green}обязательное поле${CYAN}"
			read -p "${CYAN}Пожалуйста, введите ${red}домен${CYAN}: ${yellow}" DOMAIN
		fi

		if [ -z "${DOMAIN}" ]; then
			install_web
		fi

		echo "1 → Подтвердить, 0 → Нет"
		read -p "Подтверждение: " confirm
		if [ $confirm = "0" ]; then install_web; fi
		FILE='/etc/apache2/sites-available/db.conf';
		Installation "false" "Installation and configure Web" "mkdir -p /var/www/db;a2dissite db.conf;echo \"<VirtualHost *:80>\">${FILE}; echo \"	ServerName db.${DOMAIN}\">>${FILE};echo \"	DocumentRoot /var/www/db\">>${FILE};echo \"	<Directory /var/www/db/>\">>${FILE};echo \"	Options Indexes FollowSymLinks MultiViews\">>${FILE};echo \"	AllowOverride All\">>${FILE};echo \"	Order allow,deny\">>${FILE};echo \"	allow from all\">>${FILE};echo \"	</Directory>\">>${FILE};echo \"	ErrorLog \${APACHE_LOG_DIR}/error.log\">>${FILE};echo \"	LogLevel warn\">>${FILE};echo \"	CustomLog \${APACHE_LOG_DIR}/access.log combined\">>${FILE};echo \"</VirtualHost>\">>${FILE};a2ensite db.conf;service apache2 restart; rm -r /path/web;wget -P /path/ ${MIRROR}/v3/web/web.zip; cd /path; unzip web.zip; rm web.zip;ln -s /usr/share/phpmyadmin/* /var/www/db"; sleep 2; install_web;;
	0) menu;;
	esac
}

Installation() # by Zalkarbek
{	
	echo "${2}"
	if [ "${1}" = "true" ]; then
		sh -c "${3}" > /dev/null 2>&1
	else
		sh -c "${3}"
	fi

	if [ $? -eq 0 ]; then
		echo "$(tput hpa $(tput cols))$(tput cub 6)$(tput cuu 1)${green}[OK]"; tput sgr0
	else
		echo "$(tput hpa $(tput cols))$(tput cub 6)$(tput cuu 1)${red}[ERROR]"; tput sgr0
	fi
}

menu()
{
	clear
	wow
	infomenu
	Info "• ${red}1${green} → Меню установки / настройки ${red}BSPanel${green}"
	Info "• ${red}2${green} → Меню установки ${red}WEB модулей${green}"
	Info "• ${red}3${green} → Меню установки ${red}игр${green}"
	Info "• ${red}0${green} → Выйти"
	wow1
	read -p "Пожалуйста, введите пункт меню: " case
	case $case in
		1)clear
		Info "Версия BSPanel"
		Info "----------------------"
		Info "• ${red}1${green} → BSPanel v3 ${reset}(${green}new${reset})"
		Info "• ${red}2${green} → BSPanel v2"
		Info "----------------------"
		Info "• ${red}0${green} → Вернутся в меню"

		read -p "Какую версию хотите установить или настроить: " version
		if [ "${version}" = "2" ]; then
			Installation "true" "Downloading auto-installer version 2 and run..." "wget http://cdn.bspanel.ru/bspanel.sh -O bspanelv2.sh"; sleep 2
			bash bspanelv2.sh; menu
		elif [ "${version}" = "0" ]; then
			menu
		fi

		clear

		Info "Операционная система"
		Info "----------------------------------"
		Info "• ${red}1${green} → Debian 8"
		Info "• ${red}2${green} → Debian 9"
		Info "----------------------------------"
		Info "• ${red}0${green} → Вернутся в меню"
		read -p "Пожалуйста, введите пункт меню: " os

		if [ "${os}" = "0" ]; then
			menu
		fi

		if [ "${os}" = "" ]; then
			os=1
		fi

		clear

		Info "Показать процесс выполнения?"
		Info "----------------------------------"
		Info "• ${red}1${green} → Да"
		Info "• ${red}2${green} → Нет (рекомендуется)"
		Info "----------------------------------"
		Info "• ${red}0${green} → Вернутся в меню"
		read -p "Пожалуйста, введите пункт меню: " process

		if [ "${process}" = "0" ]; then
			menu
		fi

		if [ "${process}" = "1" ]; then
			process=false
		else
			process=true
		fi

		clear

		Info "Меню установки и настройки BSPanel"
		Info "----------------------------------"
		Info "• ${red}1${green} → Установка BSPanel"
		Info "• ${red}2${green} → Настройка локации"
		Info "----------------------------------"
		Info "• ${red}0${green} → Вернутся в меню"
		read -p "Пожалуйста, введите пункт меню: " menu_select

		if [ "${menu_select}" = "0" ]; then
			menu
		fi

		if [ "${menu_select}" = "1" ]; then
			clear
			Info "Меню установки BSPanel"
			Info "----------------------"
			Info "• ${red}1${green} → С настройкой локации"
			Info "• ${red}2${green} → Без настройки локации"
			Info "----------------------"
			Info "• ${red}0${green} → Вернутся в меню"
			
			read -p "Пожалуйста, введите пункт меню: " menu_install
			case $menu_install in
				0) menu;;
			esac

			echo "1 → Домен, 0 → IP"
		    read -p "    Домен  или IP: " address_type
			if [ "${address_type}" = "0" ]; then 
				address="ip" 
			else 
				read -p "Введите домен: " address
			fi

			if [ "${menu_install}" = "1" ]; then
				params_install="bspanel"
				read -p "Введите пароль от VDS: " passwd
			else 
				params_install="wbspanel" 
				read -p "Введите пароль от VDS: " passwd
			fi

			Info "• ${red}1${green} → Подтвердить, ${red}0${green} → Отменить"
			read -p "Подтверждение установки: " confirm
			case $confirm in
				0) menu;;
			esac

			install_bspanel $address $passwd $params_install $os $process
		else
			clear
			Info "Меню настройки BSPanel"
			Info "----------------------"
			Info "• ${red}1${green} → Настройка локации на чистый сервер"
			Info "• ${red}2${green} → Настройка локации на сервере с установленным BSPanel"
			Info "----------------------"
			Info "• ${red}0${green} → Вернутся в меню"

			read -p "Пожалуйста, введите пункт меню: " menu_setting
			case $menu_setting in
				0) menu;;
			esac

			echo "1 → Домен, 0 → IP"
			read -p "    Домен  или IP: " address_type
			if [ "${address_type}" = "0" ]; then 
				address="ip" 
			else 
				read -p "Введите домен: " address; fi

			if [ "${menu_setting}" = "1" ]; then
				params_settings="setting"
			else
				read -p "Введите пароль от VDS, где установлена Панель управления: " sshpass
				read -p "Введите пароль от MySQL, где установлена Панель управления: " sqlpass
				params_settings="wsetting"
			fi

			Info "• ${red}1${green} → Подтвердить, ${red}0${green} → Отменить"
			read -p "Подтверждение настройки: " confirm
			case $confirm in
				0) menu;;
			esac

			settings_bspanel $params_settings $address $sshpass $sqlpass $os $process
		fi;;
		2) install_web;;
		3) install_games;;
		0) exit;;
	esac
}

menu